import ij.IJ;
import ij.process.*;
import ij.plugin.ContrastEnhancer;
import ij.ImagePlus;
import ij.WindowManager;
import ij.gui.GenericDialog;
import ij.plugin.PlugIn;
import ij.process.ImageConverter;
import ij.util.StringSorter;
import ij.process.ImageProcessor;
import imagescience.features.Edges;
import imagescience.images.Aspects;
import imagescience.images.Dimensions;
import imagescience.images.FloatImage;
import imagescience.images.Image;
import imagescience.segment.Thresholder;
import imagescience.utilities.I5DResource;
import imagescience.utilities.Messenger;
import ij.plugin.filter.PlugInFilter;
import java.awt.Checkbox;
import java.awt.GridBagConstraints;
import java.awt.Insets;
import java.awt.Color;
import java.awt.Panel;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import ij.*;
import ij.gui.*;
import ij.io.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.filechooser.*;
import java.io.*;
import ij.plugin.frame.*;

public class IPO_Edges extends PlugInFrame implements ActionListener, KeyListener{

    public final int WINDOW_WIDTH = 800;
    public final int WINDOW_HEIGHT = 600;

    public final int BUTTON1 = 1;
    public final int BUTTON2 = 2;
    public final int BUTTON3 = 3;
    public final int BUTTON4 = 4;
    public final int BUTTON5 = 5;
    public final int BUTTON6 = 6;
    public final int BUTTON7 = 7;
	public final int BUTTON8 = 8;
    public final int BUTTON9 = 9;
    public final int BUTTON10 = 10;
    public final int BUTTON11 = 11;
    public final int BUTTON12 = 12;
    public final int BUTTON13 = 13;
    public final int BUTTON14 = 14;
    public final int BUTTON15 = 15;
    public final int BUTTON16 = 16;
    public final int BUTTON17 = 17;
    public final int BUTTON18 = 18;
    public final int BUTTON19 = 19;

	public int finestra=1;
	public int pixels[];
	public int  r, g, b;

    public JFrame frame;
    public JPanel panel;
    public JFrame frame1;
    public JPanel panel1;

    public JLabel label1;
    public JLabel label2;
    public JLabel label3;

    public JButton fine;
    public JButton medio;
    public JButton spesso;
    public JButton bassa;
    public JButton media;
    public JButton alta;
    public JButton crea;
    public JButton reimposta;
    public JButton inverti;
    public JButton carica;

	public JButton comb1;
	public JButton comb2;
	public JButton comb3;
	public JButton comb4;
	public JButton comb5;
	public JButton comb6;
	public JButton comb7;
	public JButton comb8;
	public JButton comb9;

    public JFileChooser fc = null;
    public File dir;

	public int scelto=0;

	public String sfondo, immagine, aux;

    public ImagePlus imp = null;
    public int type = 0;

    private static boolean compute = false;
    private static boolean suppress = false;
    private static boolean val = false;

    private static String scale="1.0";
    private static String lower="";
    private static String higher="";

    double min,max;
    double scaleval, lowval=0, highval=0;
    static PlugInFrame instance;
    int  titleBarHeight = getInsets().top;
    int rows = 12;
    int columns = 5;
    int buttonWidth = 200;
    int buttonHeight = 100;
	int buttonWidth2 = 350;
    int buttonHeight2 = 50;
    int xm = 50; 					// x margin
    int ym =  titleBarHeight; 	// y margin
    int xinc = (WINDOW_WIDTH-xm*2)/columns+1;
    int yinc = (WINDOW_HEIGHT-ym)/rows-2;

    public void run(String arg) {
	msg.debug(FJ_Options.debug);
	msg.debug("FeatureJ "+FJ_Options.VERSION+": Edges");

	if (IJ.versionLessThan("1.35i")) return;

}

    public IPO_Edges() {                  	//creo la finestra
        super("IPO_Edges");
        init1();
    }

	public void init1() {                 	//creazione prima interfaccia
    frame1=new JFrame("IPO_Edges");
    panel1= new JPanel();
    frame1.add(panel1);
	finestra=1;
    label3=new JLabel("SCEGLI LA COMBINAZIONE SFONDO-IMMAGINE");

    comb1 = makeButton3("1", BUTTON8, xm, ym+yinc*2);
    comb2 = makeButton3("2", BUTTON9, xm+250, ym+yinc*2);
    comb3 = makeButton3("3", BUTTON10, xm+500, ym+yinc*2);
    comb4 = makeButton3("4", BUTTON11, xm, ym+yinc*3+100);
    comb5 = makeButton3("5", BUTTON12, xm+250, ym+yinc*3+100);
    comb6 = makeButton3("6", BUTTON13, xm+500, ym+yinc*3+100);
	comb7 = makeButton3("7", BUTTON14, xm, ym+yinc*6+100);
	comb8 = makeButton3("8", BUTTON15, xm+250, ym+yinc*6+100);
	comb9 = makeButton3("9", BUTTON16, xm+500, ym+yinc*6+100);

    label3.setBounds(70,10,730,100);
    label3.setFont(new Font("Helvetica", Font.PLAIN, 28));
    label3.setBackground(java.awt.Color.black);
    label3.setForeground(java.awt.Color.white);
    comb1.setBackground(java.awt.Color.blue);
    comb1.setForeground(java.awt.Color.yellow);
    comb2.setBackground(java.awt.Color.green);
    comb2.setForeground(java.awt.Color.red);
    comb3.setBackground(java.awt.Color.red);
    comb3.setForeground(java.awt.Color.black);
    comb4.setBackground(java.awt.Color.yellow);
    comb4.setForeground(java.awt.Color.red);
    comb5.setBackground(java.awt.Color.white);
    comb5.setForeground(java.awt.Color.black);
    comb6.setBackground(java.awt.Color.yellow);
    comb6.setForeground(java.awt.Color.black);
    comb7.setBackground(java.awt.Color.red);
    comb7.setForeground(java.awt.Color.blue);
    comb8.setBackground(java.awt.Color.green);
    comb8.setForeground(java.awt.Color.black);
    comb9.setBackground(java.awt.Color.blue);
    comb9.setForeground(java.awt.Color.green);

    panel1.add(comb1);
    panel1.add(comb2);
    panel1.add(comb3);
    panel1.add(comb4);
    panel1.add(comb5);
    panel1.add(comb6);
    panel1.add(comb7);
    panel1.add(comb8);
    panel1.add(comb9);
    panel1.add(label3);

    panel1.setLayout(null);
    panel1.setBackground(java.awt.Color.black);
    frame1.setResizable(false);
    frame1.setSize(WINDOW_WIDTH, WINDOW_HEIGHT);
    frame1.setVisible(true);
    }

	public void init() {                   	//creazione seconda interfaccia
    frame1.setVisible(false);
    frame=new JFrame("IPO_Edges");
	finestra=2;
    panel= new JPanel();
    frame.add(panel);
    label1=new JLabel(" SCEGLI LO SPESSORE DEI CONTORNI");
    label2=new JLabel(" SCEGLI LA QUANTITA' DI PARTICOLARI");

    fine = makeButton("FINE", BUTTON1, xm, ym+yinc*2);
    medio = makeButton("MEDIO", BUTTON2, xm+250, ym+yinc*2);
    spesso = makeButton("SPESSO", BUTTON3, xm+500, ym+yinc*2);
    bassa = makeButton("BASSA", BUTTON4, xm, ym+yinc*3+150);
    media = makeButton("MEDIA", BUTTON5, xm+250, ym+yinc*3+150);
    alta = makeButton("ALTA", BUTTON6, xm+500, ym+yinc*3+150);
    carica = makeButton("CARICA", BUTTON19, xm+100, ym+yinc*3+280);
    crea = makeButton("CREA", BUTTON7, xm+400, ym+yinc*3+280);
	reimposta = makeButton2("REIMPOSTA COLORI", BUTTON17, 30, ym+yinc*3+400);
	inverti = makeButton2("INVERTI COLORI", BUTTON18, 420, ym+yinc*3+400);


	if(sfondo=="giallo")
		{
			panel.setBackground(java.awt.Color.yellow);
			label1.setBackground(java.awt.Color.yellow);
			label2.setBackground(java.awt.Color.yellow);
			fine.setForeground(java.awt.Color.yellow);
			medio.setForeground(java.awt.Color.yellow);
			spesso.setForeground(java.awt.Color.yellow);
			bassa.setForeground(java.awt.Color.yellow);
			media.setForeground(java.awt.Color.yellow);
			alta.setForeground(java.awt.Color.yellow);
			crea.setForeground(java.awt.Color.yellow);
			reimposta.setForeground(java.awt.Color.yellow);
			inverti.setForeground(java.awt.Color.yellow);
            carica.setForeground(java.awt.Color.yellow);
		}
	if(sfondo=="bianco")
		{
			panel.setBackground(java.awt.Color.white);
			label1.setBackground(java.awt.Color.white);
			label2.setBackground(java.awt.Color.white);
			fine.setForeground(java.awt.Color.white);
			medio.setForeground(java.awt.Color.white);
			spesso.setForeground(java.awt.Color.white);
			bassa.setForeground(java.awt.Color.white);
			media.setForeground(java.awt.Color.white);
			alta.setForeground(java.awt.Color.white);
			crea.setForeground(java.awt.Color.white);
			reimposta.setForeground(java.awt.Color.white);
			inverti.setForeground(java.awt.Color.white);
            carica.setForeground(java.awt.Color.white);
		}
	if(sfondo=="nero")
		{
			panel.setBackground(java.awt.Color.black);
			label1.setBackground(java.awt.Color.black);
			label2.setBackground(java.awt.Color.black);
			fine.setForeground(java.awt.Color.black);
			medio.setForeground(java.awt.Color.black);
			spesso.setForeground(java.awt.Color.black);
			bassa.setForeground(java.awt.Color.black);
			media.setForeground(java.awt.Color.black);
			alta.setForeground(java.awt.Color.black);
			crea.setForeground(java.awt.Color.black);
			reimposta.setForeground(java.awt.Color.black);
			inverti.setForeground(java.awt.Color.black);
            carica.setForeground(java.awt.Color.black);
		}
	if(sfondo=="blu")
		{
			panel.setBackground(java.awt.Color.blue);
			label1.setBackground(java.awt.Color.blue);
			label2.setBackground(java.awt.Color.blue);
			fine.setForeground(java.awt.Color.blue);
			medio.setForeground(java.awt.Color.blue);
			spesso.setForeground(java.awt.Color.blue);
			bassa.setForeground(java.awt.Color.blue);
			media.setForeground(java.awt.Color.blue);
			alta.setForeground(java.awt.Color.blue);
			crea.setForeground(java.awt.Color.blue);
			reimposta.setForeground(java.awt.Color.blue);
			inverti.setForeground(java.awt.Color.blue);
            carica.setForeground(java.awt.Color.blue);
		}
	if(sfondo=="verde")
		{
			panel.setBackground(java.awt.Color.green);
			label1.setBackground(java.awt.Color.green);
			label2.setBackground(java.awt.Color.green);
			fine.setForeground(java.awt.Color.green);
			medio.setForeground(java.awt.Color.green);
			spesso.setForeground(java.awt.Color.green);
			bassa.setForeground(java.awt.Color.green);
			media.setForeground(java.awt.Color.green);
			alta.setForeground(java.awt.Color.green);
			crea.setForeground(java.awt.Color.green);
			reimposta.setForeground(java.awt.Color.green);
			inverti.setForeground(java.awt.Color.green);
            carica.setForeground(java.awt.Color.green);
        }
	if(sfondo=="rosso")
		{
			panel.setBackground(java.awt.Color.red);
			label1.setBackground(java.awt.Color.red);
			label2.setBackground(java.awt.Color.red);
			fine.setForeground(java.awt.Color.red);
			medio.setForeground(java.awt.Color.red);
			spesso.setForeground(java.awt.Color.red);
			bassa.setForeground(java.awt.Color.red);
			media.setForeground(java.awt.Color.red);
			alta.setForeground(java.awt.Color.red);
			crea.setForeground(java.awt.Color.red);
			reimposta.setForeground(java.awt.Color.red);
			inverti.setForeground(java.awt.Color.red);
            carica.setForeground(java.awt.Color.red);
		}
	if(immagine=="blu")
		{
			panel.setForeground(java.awt.Color.blue);
			label1.setForeground(java.awt.Color.blue);
			label2.setForeground(java.awt.Color.blue);
			fine.setBackground(java.awt.Color.blue);
			medio.setBackground(java.awt.Color.blue);
			spesso.setBackground(java.awt.Color.blue);
			bassa.setBackground(java.awt.Color.blue);
			media.setBackground(java.awt.Color.blue);
			alta.setBackground(java.awt.Color.blue);
			crea.setBackground(java.awt.Color.blue);
			reimposta.setBackground(java.awt.Color.blue);
			inverti.setBackground(java.awt.Color.blue);
            carica.setBackground(java.awt.Color.blue);
		}
	if(immagine=="nero")
		{
			panel.setForeground(java.awt.Color.black);
			label1.setForeground(java.awt.Color.black);
			label2.setForeground(java.awt.Color.black);
			fine.setBackground(java.awt.Color.black);
			medio.setBackground(java.awt.Color.black);
			spesso.setBackground(java.awt.Color.black);
			bassa.setBackground(java.awt.Color.black);
			media.setBackground(java.awt.Color.black);
			alta.setBackground(java.awt.Color.black);
			crea.setBackground(java.awt.Color.black);
			reimposta.setBackground(java.awt.Color.black);
			inverti.setBackground(java.awt.Color.black);
            carica.setBackground(java.awt.Color.black);
		}
	if(immagine=="bianco")
		{
			panel.setForeground(java.awt.Color.white);
			label1.setForeground(java.awt.Color.white);
			label2.setForeground(java.awt.Color.white);
			fine.setBackground(java.awt.Color.white);
			medio.setBackground(java.awt.Color.white);
			spesso.setBackground(java.awt.Color.white);
			bassa.setBackground(java.awt.Color.white);
			media.setBackground(java.awt.Color.white);
			alta.setBackground(java.awt.Color.white);
			crea.setBackground(java.awt.Color.white);
			reimposta.setBackground(java.awt.Color.white);
			inverti.setBackground(java.awt.Color.white);
            carica.setBackground(java.awt.Color.white);
		}
	if(immagine=="giallo")
		{
			panel.setForeground(java.awt.Color.yellow);
			label1.setForeground(java.awt.Color.yellow);
			label2.setForeground(java.awt.Color.yellow);
			fine.setBackground(java.awt.Color.yellow);
			medio.setBackground(java.awt.Color.yellow);
			spesso.setBackground(java.awt.Color.yellow);
			bassa.setBackground(java.awt.Color.yellow);
			media.setBackground(java.awt.Color.yellow);
			alta.setBackground(java.awt.Color.yellow);
			crea.setBackground(java.awt.Color.yellow);
			reimposta.setBackground(java.awt.Color.yellow);
			inverti.setBackground(java.awt.Color.yellow);
            carica.setBackground(java.awt.Color.yellow);
		}
	if(immagine=="verde")
		{
			panel.setForeground(java.awt.Color.green);
			label1.setForeground(java.awt.Color.green);
			label2.setForeground(java.awt.Color.green);
			fine.setBackground(java.awt.Color.green);
			medio.setBackground(java.awt.Color.green);
			spesso.setBackground(java.awt.Color.green);
			bassa.setBackground(java.awt.Color.green);
			media.setBackground(java.awt.Color.green);
			alta.setBackground(java.awt.Color.green);
			crea.setBackground(java.awt.Color.green);
			reimposta.setBackground(java.awt.Color.green);
			inverti.setBackground(java.awt.Color.green);
            carica.setBackground(java.awt.Color.green);
		}
	if(immagine=="rosso")
		{
			panel.setForeground(java.awt.Color.red);
			label1.setForeground(java.awt.Color.red);
			label2.setForeground(java.awt.Color.red);
			fine.setBackground(java.awt.Color.red);
			medio.setBackground(java.awt.Color.red);
			spesso.setBackground(java.awt.Color.red);
			bassa.setBackground(java.awt.Color.red);
			media.setBackground(java.awt.Color.red);
			alta.setBackground(java.awt.Color.red);
			crea.setBackground(java.awt.Color.red);
			reimposta.setBackground(java.awt.Color.red);
			inverti.setBackground(java.awt.Color.red);
            carica.setBackground(java.awt.Color.red);
		}

    label1.setBounds(125,0,700,100);
    label1.setFont(new Font("Helvetica", Font.PLAIN, 28));
    panel.add(label1);
    label2.setBounds(125,200,700,100);
    label2.setFont(new Font("Helvetica", Font.PLAIN, 28));
    panel.add(label2);

    panel.add(fine);
    panel.add(medio);
    panel.add(spesso);
    panel.add(bassa);
    panel.add(media);
    panel.add(alta);
    panel.add(carica);
    panel.add(crea);


    frame.setSize(WINDOW_WIDTH, WINDOW_HEIGHT+30);
    panel.setLayout(null);
    frame.setResizable(false);
    frame.setVisible(true);
    }

    JButton makeButton(String label, int op, int x, int y) {   		//metodo che crea i bottoni
        JButton button = new JButton(label);
        button.setBackground(java.awt.Color.white);
        button.setForeground(java.awt.Color.black);
        button.addActionListener(this);
        button.addKeyListener(this);
        button.setName(""+op);
        button.setFont(new Font("Helvetica", Font.PLAIN, 40));
        button.setBounds(x, y, buttonWidth, buttonHeight);
        return button;
    }

	JButton makeButton2(String label, int op, int x, int y) {   		//metodo che crea i bottoni 2
        JButton button = new JButton(label);
        button.setBackground(java.awt.Color.white);
        button.setForeground(java.awt.Color.black);
        button.addActionListener(this);
        button.addKeyListener(this);
        button.setName(""+op);
        button.setFont(new Font("Helvetica", Font.PLAIN, 28));
        button.setBounds(x, y, buttonWidth2, buttonHeight2);
        panel.add(button);
        return button;
    }

    JButton makeButton3(String label, int op, int x, int y) {   		//metodo che crea i bottoni 3
        JButton button = new JButton(label);
        button.setBackground(java.awt.Color.white);
        button.setForeground(java.awt.Color.black);
        button.addActionListener(this);
        button.addKeyListener(this);
        button.setName(""+op);
        button.setFont(new Font("Helvetica", Font.PLAIN, 70));
        button.setBounds(x, y, buttonWidth, buttonHeight);
        return button;
    }



	public void windowClosing(WindowEvent e) {          			//chiusura finestra
        super.windowClosing(e);
        instance = null;
    }


    public void createEdge() {												//metodo che crea gli edge
        try {
	    final Image img = Image.wrap(imp);
	    Image newimg = new FloatImage(img);
	    boolean lowthres = true, highthres = true;
	    try {  scaleval = Double.parseDouble(scale); }
	    catch (Exception e) { throw new IllegalArgumentException("Invalid smoothing scale value"); }
	    try { if (lower.equals("")) lowthres = false; else lowval = Double.parseDouble(lower); }
	    catch (Exception e) { throw new IllegalArgumentException("Invalid lower threshold value"); }
	    try { if (higher.equals("")) highthres = false; else highval = Double.parseDouble(higher); }
	    catch (Exception e) { throw new IllegalArgumentException("Invalid higher threshold value"); }
		final Aspects aspects = newimg.aspects();
		if (!FJ_Options.isotropic) newimg.aspects(new Aspects());
		final Edges edges = new Edges();
		edges.debug(FJ_Options.debug);
		edges.separate(FJ_Options.separate);
		newimg = edges.run(newimg,scaleval,suppress);
		newimg.aspects(aspects);
	    final int threscode = (lowthres?10:0) + (highthres?1:0);
	    final Thresholder thres = new Thresholder();
	    thres.debug(FJ_Options.debug);
	    switch (threscode)
			{
				case 1: { thres.hard(newimg,highval); break; }
				case 10: { thres.hard(newimg,lowval); break; }
				case 11: { thres.hysteresis(newimg,lowval,highval); break; }
			}
	    ImagePlus newimp = newimg.imageplus();
	    newimp.getCalibration().setUnit(imp.getCalibration().getUnit());
	    ImageProcessor newip = newimp.getProcessor();
		int w=newip.getWidth();
		int h=newip.getHeight();
	    final double[] minmax = newimg.extrema();
	    newip.setMinAndMax(minmax[0],minmax[1]);
	    boolean i5dinstalled = false;
	    try { Class.forName("Image5D"); i5dinstalled = true; } catch (Exception e) { }
	    if (i5dinstalled)
			{
				final Dimensions newdims = newimg.dimensions();
				if (newdims.t > 1 || newdims.s > 1)
				newimp = I5DResource.convert(newimp,true);
			}
	    newimp.changes = FJ_Options.asksave;

		Rectangle roi=newip.getRoi();

		new ImageConverter(newimp).convertToRGB();
		newip = newimp.getProcessor();

		pixels=(int[])newip.getPixels();

		if(sfondo=="verde")
			{
				for(int i=roi.y; i<roi.y+roi.height; i++)
					{
						int offset=i*w;
						for(int j=roi.x; j<roi.x+roi.width; j++)
							{
								int pos=offset+j;
								int c=pixels[pos];

								r=(c&0xff0000)>>16;
								g=(c&0x00ff00)>>8;
								b=(c&0x0000ff);

								if(r==0 && g==0 && b==0)
									{
										r=0;
										g=255;
										b=0;
										sfondo="verde";
										pixels[pos]=((r & 0xff)<<16)+((g & 0xff)<<8)+(b & 0xff);
									}
							}
					}
			}

		if(sfondo=="rosso")
			{
				for(int i=roi.y; i<roi.y+roi.height; i++)
					{
						int offset=i*w;
						for(int j=roi.x; j<roi.x+roi.width; j++)
							{
								int pos=offset+j;
								int c=pixels[pos];

								r=(c&0xff0000)>>16;
								g=(c&0x00ff00)>>8;
								b=(c&0x0000ff);

								if(r==0 && g==0 && b==0)
									{
										r=255;
										g=0;
										b=0;
										sfondo="rosso";
										pixels[pos]=((r & 0xff)<<16)+((g & 0xff)<<8)+(b & 0xff);
									}
							}
					}
			}

		if(sfondo=="blu")
			{
				for(int i=roi.y; i<roi.y+roi.height; i++)
					{
						int offset=i*w;
						for(int j=roi.x; j<roi.x+roi.width; j++)
							{
								int pos=offset+j;
								int c=pixels[pos];

								r=(c&0xff0000)>>16;
								g=(c&0x00ff00)>>8;
								b=(c&0x0000ff);

								if(r==0 && g==0 && b==0)
									{
										r=0;
										g=0;
										b=255;
										sfondo="blu";
										pixels[pos]=((r & 0xff)<<16)+((g & 0xff)<<8)+(b & 0xff);
									}
							}
					}
			}

		if(sfondo=="bianco")
			{
				for(int i=roi.y; i<roi.y+roi.height; i++)
					{
						int offset=i*w;
						for(int j=roi.x; j<roi.x+roi.width; j++)
							{
								int pos=offset+j;
								int c=pixels[pos];

								r=(c&0xff0000)>>16;
								g=(c&0x00ff00)>>8;
								b=(c&0x0000ff);

								if(r==0 && g==0 && b==0)
									{
										r=254;
										g=255;
										b=255;
										sfondo="bianco";
										pixels[pos]=((r & 0xff)<<16)+((g & 0xff)<<8)+(b & 0xff);
									}
							}
					}
			}

		if(sfondo=="giallo")
			{
				for(int i=roi.y; i<roi.y+roi.height; i++)
					{
						int offset=i*w;
						for(int j=roi.x; j<roi.x+roi.width; j++)
							{
								int pos=offset+j;
								int c=pixels[pos];

								r=(c&0xff0000)>>16;
								g=(c&0x00ff00)>>8;
								b=(c&0x0000ff);

								if(r==0 && g==0 && b==0)
									{
										r=255;
										g=255;
										b=0;
										sfondo="giallo";
										pixels[pos]=((r & 0xff)<<16)+((g & 0xff)<<8)+(b & 0xff);
									}
							}
					}
			}

		if(sfondo=="nero")
			{
				for(int i=roi.y; i<roi.y+roi.height; i++)
					{
						int offset=i*w;
						for(int j=roi.x; j<roi.x+roi.width; j++)
							{
								int pos=offset+j;
								int c=pixels[pos];

								r=(c&0xff0000)>>16;
								g=(c&0x00ff00)>>8;
								b=(c&0x0000ff);

								if(r==0 && g==0 && b==0)
									{
										r=0;
										g=0;
										b=0;
										sfondo="nero";
										pixels[pos]=((r & 0xff)<<16)+((g & 0xff)<<8)+(b & 0xff);
									}
							}
					}
			}

		if(immagine=="verde")
			{
				for(int i=roi.y; i<roi.y+roi.height; i++)
					{
						int offset=i*w;
						for(int j=roi.x; j<roi.x+roi.width; j++)
							{
								int pos=offset+j;
								int c=pixels[pos];

								r=(c&0xff0000)>>16;
								g=(c&0x00ff00)>>8;
								b=(c&0x0000ff);

								if(r==255 && g==255 && b==255)
									{
										r=0;
										g=255;
										b=0;
										immagine="verde";
										pixels[pos]=((r & 0xff)<<16)+((g & 0xff)<<8)+(b & 0xff);
									}
							}
					}
			}

		if(immagine=="rosso")
			{
				for(int i=roi.y; i<roi.y+roi.height; i++)
					{
						int offset=i*w;
						for(int j=roi.x; j<roi.x+roi.width; j++)
							{
								int pos=offset+j;
								int c=pixels[pos];

								r=(c&0xff0000)>>16;
								g=(c&0x00ff00)>>8;
								b=(c&0x0000ff);

								if(r==255 && g==255 && b==255)
									{
										r=255;
										g=0;
										b=0;
										immagine="rosso";
										pixels[pos]=((r & 0xff)<<16)+((g & 0xff)<<8)+(b & 0xff);
									}
							}
					}
			}

		if(immagine=="blu")
			{
				for(int i=roi.y; i<roi.y+roi.height; i++)
					{
						int offset=i*w;
						for(int j=roi.x; j<roi.x+roi.width; j++)
							{
								int pos=offset+j;
								int c=pixels[pos];

								r=(c&0xff0000)>>16;
								g=(c&0x00ff00)>>8;
								b=(c&0x0000ff);

								if(r==255 && g==255 && b==255)
									{
										r=0;
										g=0;
										b=255;
										immagine="blu";
										pixels[pos]=((r & 0xff)<<16)+((g & 0xff)<<8)+(b & 0xff);
									}
							}
					}
			}

		if(immagine=="bianco")
			{
				for(int i=roi.y; i<roi.y+roi.height; i++)
					{
						int offset=i*w;
						for(int j=roi.x; j<roi.x+roi.width; j++)
							{
								int pos=offset+j;
								int c=pixels[pos];

								r=(c&0xff0000)>>16;
								g=(c&0x00ff00)>>8;
								b=(c&0x0000ff);

								if(r==255 && g==255 && b==255)
									{
										r=255;
										g=255;
										b=255;
										immagine="bianco";
										pixels[pos]=((r & 0xff)<<16)+((g & 0xff)<<8)+(b & 0xff);
									}
							}
					}
			}

		if(immagine=="giallo")
			{
				for(int i=roi.y; i<roi.y+roi.height; i++)
					{
						int offset=i*w;
						for(int j=roi.x; j<roi.x+roi.width; j++)
							{
								int pos=offset+j;
								int c=pixels[pos];

								r=(c&0xff0000)>>16;
								g=(c&0x00ff00)>>8;
								b=(c&0x0000ff);

								if(r==255 && g==255 && b==255)
									{
										r=255;
										g=255;
										b=0;
										immagine="giallo";
										pixels[pos]=((r & 0xff)<<16)+((g & 0xff)<<8)+(b & 0xff);
									}
							}
					}
			}

		if(immagine=="nero")
			{
				for(int i=roi.y; i<roi.y+roi.height; i++)
					{
						int offset=i*w;
						for(int j=roi.x; j<roi.x+roi.width; j++)
							{
								int pos=offset+j;
								int c=pixels[pos];

								r=(c&0xff0000)>>16;
								g=(c&0x00ff00)>>8;
								b=(c&0x0000ff);

								if(r==255 && g==255 && b==255)
									{
										r=0;
										g=0;
										b=0;
										immagine="nero";
										pixels[pos]=((r & 0xff)<<16)+((g & 0xff)<<8)+(b & 0xff);
									}
							}
					}
			}



		newimp.setTitle("IPOImmagine");
		newimp.show();

	    } catch (OutOfMemoryError e) {
	    error("Not enough memory for this operation");

	    } catch (Exception e) {
	    error("Non  stata aperta alcuna immagine");
		frame.toFront();
	    }
    }


    public void actionPerformed(ActionEvent evt) {      				//eventi bottoni
    JButton b = (JButton)evt.getSource();
    int op = Integer.parseInt(b.getName());

	if (op==BUTTON17 && finestra==2)	//reimposta
		{
        frame.setVisible(false);
		init1();
		compute=false;
		val=false;
	}
	if (op==BUTTON1 && finestra==2)	//fine
        {
			fine.setBackground(java.awt.Color.pink);
			if(immagine=="nero")
				{
					medio.setBackground(java.awt.Color.black);
					spesso.setBackground(java.awt.Color.black);
				}
			if(immagine=="bianco")
				{
					medio.setBackground(java.awt.Color.white);
					spesso.setBackground(java.awt.Color.white);
				}
			if(immagine=="giallo")
				{
					medio.setBackground(java.awt.Color.yellow);
					spesso.setBackground(java.awt.Color.yellow);
				}
			if(immagine=="blu")
				{
					medio.setBackground(java.awt.Color.blue);
					spesso.setBackground(java.awt.Color.blue);
				}
			if(immagine=="verde")
				{
					medio.setBackground(java.awt.Color.green);
					spesso.setBackground(java.awt.Color.green);
				}
			if(immagine=="rosso")
				{
					medio.setBackground(java.awt.Color.red);
					spesso.setBackground(java.awt.Color.red);
				}
                compute = true;
                scale="1.0";
        }
    if (op==BUTTON2 && finestra==2)	//medio
        {
            medio.setBackground(java.awt.Color.pink);
            if(immagine=="nero")
				{
					fine.setBackground(java.awt.Color.black);
					spesso.setBackground(java.awt.Color.black);
				}
			if(immagine=="bianco")
				{
					fine.setBackground(java.awt.Color.white);
					spesso.setBackground(java.awt.Color.white);
				}
			if(immagine=="giallo")
				{
					fine.setBackground(java.awt.Color.yellow);
					spesso.setBackground(java.awt.Color.yellow);
				}
			if(immagine=="blu")
				{
					fine.setBackground(java.awt.Color.blue);
					spesso.setBackground(java.awt.Color.blue);
				}
			if(immagine=="verde")
				{
					fine.setBackground(java.awt.Color.green);
					spesso.setBackground(java.awt.Color.green);
				}
			if(immagine=="rosso")
				{
					fine.setBackground(java.awt.Color.red);
					spesso.setBackground(java.awt.Color.red);
				}
                compute = true;
                scale="2.0";
        }
    if (op==BUTTON3 && finestra==2)	//spesso
        {
            spesso.setBackground(java.awt.Color.pink);
            if(immagine=="nero")
				{
					fine.setBackground(java.awt.Color.black);
					medio.setBackground(java.awt.Color.black);
				}
			if(immagine=="bianco")
				{
					fine.setBackground(java.awt.Color.white);
					medio.setBackground(java.awt.Color.white);
				}
			if(immagine=="giallo")
				{
					fine.setBackground(java.awt.Color.yellow);
					medio.setBackground(java.awt.Color.yellow);
				}
			if(immagine=="blu")
				{
					fine.setBackground(java.awt.Color.blue);
					medio.setBackground(java.awt.Color.blue);
				}
			if(immagine=="verde")
				{
					fine.setBackground(java.awt.Color.green);
					medio.setBackground(java.awt.Color.green);
				}
			if(immagine=="rosso")
				{
					fine.setBackground(java.awt.Color.red);
					medio.setBackground(java.awt.Color.red);
				}
                compute = true;
                scale="3.0";
        }
    if (op==BUTTON4 && finestra==2)	//bassa
        {
			bassa.setBackground(java.awt.Color.pink);
			if(immagine=="nero")
				{
					alta.setBackground(java.awt.Color.black);
					media.setBackground(java.awt.Color.black);
				}
			if(immagine=="bianco")
				{
					alta.setBackground(java.awt.Color.white);
					media.setBackground(java.awt.Color.white);
				}
			if(immagine=="giallo")
				{
					alta.setBackground(java.awt.Color.yellow);
					media.setBackground(java.awt.Color.yellow);
				}
			if(immagine=="blu")
				{
					alta.setBackground(java.awt.Color.blue);
					media.setBackground(java.awt.Color.blue);
				}
			if(immagine=="verde")
				{
					alta.setBackground(java.awt.Color.green);
					media.setBackground(java.awt.Color.green);
				}
			if(immagine=="rosso")
				{
					alta.setBackground(java.awt.Color.red);
					media.setBackground(java.awt.Color.red);
				}
                val=true;
                lower="12.0";
                higher="16.0";
        }
    if (op==BUTTON5 && finestra==2)	//media
        {
            media.setBackground(java.awt.Color.pink);
			if(immagine=="nero")
				{
					alta.setBackground(java.awt.Color.black);
					bassa.setBackground(java.awt.Color.black);
				}
			if(immagine=="bianco")
				{
					alta.setBackground(java.awt.Color.white);
					bassa.setBackground(java.awt.Color.white);
				}
			if(immagine=="giallo")
				{
					alta.setBackground(java.awt.Color.yellow);
					bassa.setBackground(java.awt.Color.yellow);
				}
			if(immagine=="blu")
				{
					alta.setBackground(java.awt.Color.blue);
					bassa.setBackground(java.awt.Color.blue);
				}
			if(immagine=="verde")
				{
					alta.setBackground(java.awt.Color.green);
					bassa.setBackground(java.awt.Color.green);
				}
			if(immagine=="rosso")
				{
					alta.setBackground(java.awt.Color.red);
					bassa.setBackground(java.awt.Color.red);
				}
                val=true;
                lower="8.0";
                higher="12.0";
        }
    if (op==BUTTON6 && finestra==2)	//alta
        {
                alta.setBackground(java.awt.Color.pink);
			if(immagine=="nero")
				{
					media.setBackground(java.awt.Color.black);
					bassa.setBackground(java.awt.Color.black);
				}
			if(immagine=="bianco")
				{
					media.setBackground(java.awt.Color.white);
					bassa.setBackground(java.awt.Color.white);
				}
			if(immagine=="giallo")
				{
					media.setBackground(java.awt.Color.yellow);
					bassa.setBackground(java.awt.Color.yellow);
				}
			if(immagine=="blu")
				{
					media.setBackground(java.awt.Color.blue);
					bassa.setBackground(java.awt.Color.blue);
				}
			if(immagine=="verde")
				{
					media.setBackground(java.awt.Color.green);
					bassa.setBackground(java.awt.Color.green);
				}
			if(immagine=="rosso")
				{
					media.setBackground(java.awt.Color.red);
					bassa.setBackground(java.awt.Color.red);
				}
                val=true;
                lower="2.0";
                higher="6.0";
         }

	if(op==BUTTON7 && finestra==2)		//crea
		{
		if (compute && val)
            {
            crea.setBackground(java.awt.Color.pink);
            createEdge();
            if(immagine=="nero")
					crea.setBackground(java.awt.Color.black);
			if(immagine=="bianco")
					crea.setBackground(java.awt.Color.white);
			if(immagine=="giallo")
					crea.setBackground(java.awt.Color.yellow);
			if(immagine=="blu")
					crea.setBackground(java.awt.Color.blue);
			if(immagine=="verde")
					crea.setBackground(java.awt.Color.green);
			if(immagine=="rosso")
					crea.setBackground(java.awt.Color.red);
            }
        else if(!compute&&!val)
        {
	    error("Selezionare lo spessore e la quantit di edge");
		frame.toFront();
	    return;
	    }
		else if(!compute)
        {
	    error("Selezionare lo spessore");
		frame.toFront();
	    return;
	    }
        else if(!val)
        {
	    error("Selezionare la quantit di particolari");
		frame.toFront();
	    return;
	    }
    }

	if(op==BUTTON8 && finestra==1)		//blu-giallo
		{
		sfondo="blu";
		immagine="giallo";
	}
	if(op==BUTTON9 && finestra==1)		//verde-rosso
		{
		sfondo="verde";
		immagine="rosso";
	}
	if(op==BUTTON10 && finestra==1)	//rosso-nero
		{
		sfondo="rosso";
		immagine="nero";
	}
	if(op==BUTTON11 && finestra==1)	//giallo-rosso
		{
		sfondo="giallo";
		immagine="rosso";
	}
	if(op==BUTTON12 && finestra==1)	//bianco-nero
		{
		sfondo="bianco";
		immagine="nero";
	}
	if(op==BUTTON13 && finestra==1)	//giallo-nero
		{
		sfondo="giallo";
		immagine="nero";
	}
	if(op==BUTTON14 && finestra==1)	//rosso-blu
		{
		sfondo="rosso";
		immagine="blu";
	}
	if(op==BUTTON15 && finestra==1)	//verde-nero
		{
		sfondo="verde";
		immagine="nero";
	}
	if(op==BUTTON16 && finestra==1)	//blu-verde
		{
		sfondo="blu";
		immagine="verde";
	}
	if(op==BUTTON18 && finestra==2)	//inverti
		{
		aux=sfondo;
		sfondo=immagine;
		immagine=aux;

		if(sfondo=="giallo")
		{
			panel.setBackground(java.awt.Color.yellow);
			label1.setBackground(java.awt.Color.yellow);
			label2.setBackground(java.awt.Color.yellow);
			fine.setForeground(java.awt.Color.yellow);
			medio.setForeground(java.awt.Color.yellow);
			spesso.setForeground(java.awt.Color.yellow);
			bassa.setForeground(java.awt.Color.yellow);
			media.setForeground(java.awt.Color.yellow);
			alta.setForeground(java.awt.Color.yellow);
			crea.setForeground(java.awt.Color.yellow);
			reimposta.setForeground(java.awt.Color.yellow);
			inverti.setForeground(java.awt.Color.yellow);
            carica.setForeground(java.awt.Color.yellow);
        }
	if(sfondo=="bianco")
		{
			panel.setBackground(java.awt.Color.white);
			label1.setBackground(java.awt.Color.white);
			label2.setBackground(java.awt.Color.white);
			fine.setForeground(java.awt.Color.white);
			medio.setForeground(java.awt.Color.white);
			spesso.setForeground(java.awt.Color.white);
			bassa.setForeground(java.awt.Color.white);
			media.setForeground(java.awt.Color.white);
			alta.setForeground(java.awt.Color.white);
			crea.setForeground(java.awt.Color.white);
			reimposta.setForeground(java.awt.Color.white);
			inverti.setForeground(java.awt.Color.white);
            carica.setForeground(java.awt.Color.white);
		}
	if(sfondo=="nero")
		{
			panel.setBackground(java.awt.Color.black);
			label1.setBackground(java.awt.Color.black);
			label2.setBackground(java.awt.Color.black);
			fine.setForeground(java.awt.Color.black);
			medio.setForeground(java.awt.Color.black);
			spesso.setForeground(java.awt.Color.black);
			bassa.setForeground(java.awt.Color.black);
			media.setForeground(java.awt.Color.black);
			alta.setForeground(java.awt.Color.black);
			crea.setForeground(java.awt.Color.black);
			reimposta.setForeground(java.awt.Color.black);
			inverti.setForeground(java.awt.Color.black);
            carica.setForeground(java.awt.Color.black);
		}
	if(sfondo=="blu")
		{
			panel.setBackground(java.awt.Color.blue);
			label1.setBackground(java.awt.Color.blue);
			label2.setBackground(java.awt.Color.blue);
			fine.setForeground(java.awt.Color.blue);
			medio.setForeground(java.awt.Color.blue);
			spesso.setForeground(java.awt.Color.blue);
			bassa.setForeground(java.awt.Color.blue);
			media.setForeground(java.awt.Color.blue);
			alta.setForeground(java.awt.Color.blue);
			crea.setForeground(java.awt.Color.blue);
			reimposta.setForeground(java.awt.Color.blue);
			inverti.setForeground(java.awt.Color.blue);
            carica.setForeground(java.awt.Color.blue);
		}
	if(sfondo=="verde")
		{
			panel.setBackground(java.awt.Color.green);
			label1.setBackground(java.awt.Color.green);
			label2.setBackground(java.awt.Color.green);
			fine.setForeground(java.awt.Color.green);
			medio.setForeground(java.awt.Color.green);
			spesso.setForeground(java.awt.Color.green);
			bassa.setForeground(java.awt.Color.green);
			media.setForeground(java.awt.Color.green);
			alta.setForeground(java.awt.Color.green);
			crea.setForeground(java.awt.Color.green);
			reimposta.setForeground(java.awt.Color.green);
			inverti.setForeground(java.awt.Color.green);
            carica.setForeground(java.awt.Color.green);
		}
	if(sfondo=="rosso")
		{
			panel.setBackground(java.awt.Color.red);
			label1.setBackground(java.awt.Color.red);
			label2.setBackground(java.awt.Color.red);
			fine.setForeground(java.awt.Color.red);
			medio.setForeground(java.awt.Color.red);
			spesso.setForeground(java.awt.Color.red);
			bassa.setForeground(java.awt.Color.red);
			media.setForeground(java.awt.Color.red);
			alta.setForeground(java.awt.Color.red);
			crea.setForeground(java.awt.Color.red);
			reimposta.setForeground(java.awt.Color.red);
			inverti.setForeground(java.awt.Color.red);
            carica.setForeground(java.awt.Color.red);
		}
	if(immagine=="blu")
		{
			panel.setForeground(java.awt.Color.blue);
			label1.setForeground(java.awt.Color.blue);
			label2.setForeground(java.awt.Color.blue);
			fine.setBackground(java.awt.Color.blue);
			medio.setBackground(java.awt.Color.blue);
			spesso.setBackground(java.awt.Color.blue);
			bassa.setBackground(java.awt.Color.blue);
			media.setBackground(java.awt.Color.blue);
			alta.setBackground(java.awt.Color.blue);
			crea.setBackground(java.awt.Color.blue);
			reimposta.setBackground(java.awt.Color.blue);
			inverti.setBackground(java.awt.Color.blue);
            carica.setBackground(java.awt.Color.blue);
		}
	if(immagine=="nero")
		{
			panel.setForeground(java.awt.Color.black);
			label1.setForeground(java.awt.Color.black);
			label2.setForeground(java.awt.Color.black);
			fine.setBackground(java.awt.Color.black);
			medio.setBackground(java.awt.Color.black);
			spesso.setBackground(java.awt.Color.black);
			bassa.setBackground(java.awt.Color.black);
			media.setBackground(java.awt.Color.black);
			alta.setBackground(java.awt.Color.black);
			crea.setBackground(java.awt.Color.black);
			reimposta.setBackground(java.awt.Color.black);
			inverti.setBackground(java.awt.Color.black);
            carica.setBackground(java.awt.Color.black);
		}
	if(immagine=="bianco")
		{
			panel.setForeground(java.awt.Color.white);
			label1.setForeground(java.awt.Color.white);
			label2.setForeground(java.awt.Color.white);
			fine.setBackground(java.awt.Color.white);
			medio.setBackground(java.awt.Color.white);
			spesso.setBackground(java.awt.Color.white);
			bassa.setBackground(java.awt.Color.white);
			media.setBackground(java.awt.Color.white);
			alta.setBackground(java.awt.Color.white);
			crea.setBackground(java.awt.Color.white);
			reimposta.setBackground(java.awt.Color.white);
			inverti.setBackground(java.awt.Color.white);
            carica.setBackground(java.awt.Color.white);
		}
	if(immagine=="giallo")
		{
			panel.setForeground(java.awt.Color.yellow);
			label1.setForeground(java.awt.Color.yellow);
			label2.setForeground(java.awt.Color.yellow);
			fine.setBackground(java.awt.Color.yellow);
			medio.setBackground(java.awt.Color.yellow);
			spesso.setBackground(java.awt.Color.yellow);
			bassa.setBackground(java.awt.Color.yellow);
			media.setBackground(java.awt.Color.yellow);
			alta.setBackground(java.awt.Color.yellow);
			crea.setBackground(java.awt.Color.yellow);
			reimposta.setBackground(java.awt.Color.yellow);
			inverti.setBackground(java.awt.Color.yellow);
            carica.setBackground(java.awt.Color.yellow);
		}
	if(immagine=="verde")
		{
			panel.setForeground(java.awt.Color.green);
			label1.setForeground(java.awt.Color.green);
			label2.setForeground(java.awt.Color.green);
			fine.setBackground(java.awt.Color.green);
			medio.setBackground(java.awt.Color.green);
			spesso.setBackground(java.awt.Color.green);
			bassa.setBackground(java.awt.Color.green);
			media.setBackground(java.awt.Color.green);
			alta.setBackground(java.awt.Color.green);
			crea.setBackground(java.awt.Color.green);
			reimposta.setBackground(java.awt.Color.green);
			inverti.setBackground(java.awt.Color.green);
            carica.setBackground(java.awt.Color.green);
		}
	if(immagine=="rosso")
		{
			panel.setForeground(java.awt.Color.red);
			label1.setForeground(java.awt.Color.red);
			label2.setForeground(java.awt.Color.red);
			fine.setBackground(java.awt.Color.red);
			medio.setBackground(java.awt.Color.red);
			spesso.setBackground(java.awt.Color.red);
			bassa.setBackground(java.awt.Color.red);
			media.setBackground(java.awt.Color.red);
			alta.setBackground(java.awt.Color.red);
			crea.setBackground(java.awt.Color.red);
			reimposta.setBackground(java.awt.Color.red);
			inverti.setBackground(java.awt.Color.red);
            carica.setBackground(java.awt.Color.red);
		}
		compute=false;
		val=false;
    }
    if ((op==BUTTON8 || op==BUTTON9 || op==BUTTON10 || op==BUTTON11 || op==BUTTON12 || op==BUTTON13 || op==BUTTON14 || op==BUTTON15 || op==BUTTON16)  && finestra==1)
	    {
            init();
	    }


    if(op==BUTTON19 && finestra==2)    //carica
		{
            ContrastEnhancer ce = new ContrastEnhancer();
			fc = new JFileChooser();
			if (dir==null)
				{
					String sdir = OpenDialog.getDefaultDirectory();
					if (sdir!=null)
					dir = new File(sdir);
				}
			if (dir!=null)
				fc.setCurrentDirectory(dir);
			int choose = fc.showDialog(IJ.getInstance(),"Apri l'immagine");
			if (choose!=JFileChooser.APPROVE_OPTION)
				return;
			File[] files  = fc.getSelectedFiles();
			if (files.length==0)
				{
					files = new File[1];
					files[0] = fc.getSelectedFile();
				}
			String path = fc.getCurrentDirectory().getPath()+Prefs.getFileSeparator();
			dir = fc.getCurrentDirectory();
			Opener opener = new Opener();
			for (int i=0; i<files.length; i++)
				{
					imp = opener.openImage(path, files[i].getName());
					if (imp!=null)
						{
                            ImageProcessor ip=imp.getProcessor();
                            ce.equalize(ip);
							type=imp.getType();
							if (type != ImagePlus.GRAY8 && type != ImagePlus.GRAY16 && type != ImagePlus.GRAY32)   ////////l'immagine deve essere in scala di grigi
								{
									new ImageConverter(imp).convertToGray8();
									imp.updateAndDraw();
								}

                                 imp.show();
                                 frame.toFront();
						}

					else
						{
							error("Non  stata aperta nessuna immagine");
							return;
						}
				}
		}
    }

    public void keyTyped(KeyEvent ev) { 								//metodo che riconosce i comandi da tastiera
	        char c=ev.getKeyChar();

			if(c=='5' && finestra==1)		//nero-bianco
				{
					sfondo="nero";
					immagine="bianco";
				}
			if(c=='1' && finestra==1)		//blu-giallo
				{
					sfondo="blu";
					immagine="giallo";
				}
			if(c=='2' && finestra==1)		//verde-rosso
				{
					sfondo="verde";
					immagine="rosso";
				}
			if(c=='3' && finestra==1)		//rosso-nero
				{
					sfondo="rosso";
					immagine="nero";
				}
			if(c=='7' && finestra==1)		//rosso-blu
				{
					sfondo="rosso";
					immagine="blu";
				}
			if(c=='6' && finestra==1)		//giallo-nero
				{
					sfondo="giallo";
					immagine="nero";
				}
			if(c=='4' && finestra==1)		//giallo-rosso
				{
					sfondo="giallo";
					immagine="rosso";
				}
			if(c=='9' && finestra==1)		//blu-verde
				{
					sfondo="blu";
					immagine="verde";
				}
			if(c=='8' && finestra==1)		//verde-nero
				{
					sfondo="verde";
					immagine="nero";
				}
			if((c=='1' || c=='2' || c=='3' || c=='4' || c=='5' || c=='6' || c=='7' || c=='8' || c=='9') && finestra==1)
				{
					init();
				}
			if ((c=='c' || c=='C') && finestra==2)	//crea
				{
					if (compute && val)
						{
						crea.setBackground(java.awt.Color.pink);
						createEdge();
						if(immagine=="nero")
								crea.setBackground(java.awt.Color.black);
						if(immagine=="bianco")
								crea.setBackground(java.awt.Color.white);
						if(immagine=="giallo")
								crea.setBackground(java.awt.Color.yellow);
						if(immagine=="blu")
								crea.setBackground(java.awt.Color.blue);
						if(immagine=="verde")
								crea.setBackground(java.awt.Color.green);
						if(immagine=="rosso")
								crea.setBackground(java.awt.Color.red);
						}
					else if(!compute&&!val)
					{
					error("Selezionare lo spessore e la quantit di edge");
					frame.toFront();
					return;
					}
					else if(!compute)
					{
					error("Selezionare lo spessore");
					frame.toFront();
					return;
					}
					else if(!val)
					{
					error("Selezionare la quantit di particolari");
					frame.toFront();
					return;
					}
				}
			if((c=='l' || c=='L') && finestra==2)		//carica
				{
					ContrastEnhancer ce = new ContrastEnhancer();
					fc = new JFileChooser();
					if (dir==null)
						{
							String sdir = OpenDialog.getDefaultDirectory();
							if (sdir!=null)
							dir = new File(sdir);
						}
					if (dir!=null)
						fc.setCurrentDirectory(dir);
					int choose = fc.showDialog(IJ.getInstance(),"Apri l'immagine");
					if (choose!=JFileChooser.APPROVE_OPTION)
						return;
					File[] files  = fc.getSelectedFiles();
					if (files.length==0)
						{
							files = new File[1];
							files[0] = fc.getSelectedFile();
						}
					String path = fc.getCurrentDirectory().getPath()+Prefs.getFileSeparator();
					dir = fc.getCurrentDirectory();
					Opener opener = new Opener();
					for (int i=0; i<files.length; i++)
						{
							imp = opener.openImage(path, files[i].getName());
							if (imp!=null)
								{
									ImageProcessor ip=imp.getProcessor();
									ce.equalize(ip);
									type=imp.getType();
									if (type != ImagePlus.GRAY8 && type != ImagePlus.GRAY16 && type != ImagePlus.GRAY32)   ////////l'immagine deve essere in scala di grigi
										{
											new ImageConverter(imp).convertToGray8();
											imp.updateAndDraw();
										}

										 imp.show();
										 frame.toFront();
								}

							else
								{
									error("Non  stata aperta nessuna immagine");
									return;
								}
						}
				}

            if((c=='f' || c=='F') && finestra==2)		//fine
                {
			fine.setBackground(java.awt.Color.pink);
			if(immagine=="nero")
				{
					medio.setBackground(java.awt.Color.black);
					spesso.setBackground(java.awt.Color.black);
				}
			if(immagine=="bianco")
				{
					medio.setBackground(java.awt.Color.white);
					spesso.setBackground(java.awt.Color.white);
				}
			if(immagine=="giallo")
				{
					medio.setBackground(java.awt.Color.yellow);
					spesso.setBackground(java.awt.Color.yellow);
				}
			if(immagine=="blu")
				{
					medio.setBackground(java.awt.Color.blue);
					spesso.setBackground(java.awt.Color.blue);
				}
			if(immagine=="verde")
				{
					medio.setBackground(java.awt.Color.green);
					spesso.setBackground(java.awt.Color.green);
				}
			if(immagine=="rosso")
				{
					medio.setBackground(java.awt.Color.red);
					spesso.setBackground(java.awt.Color.red);
				}
                compute = true;
                scale="1.0";
        }
            if((c=='m' || c=='M') && finestra==2)	//medio
				{
            medio.setBackground(java.awt.Color.pink);
            if(immagine=="nero")
				{
					fine.setBackground(java.awt.Color.black);
					spesso.setBackground(java.awt.Color.black);
				}
			if(immagine=="bianco")
				{
					fine.setBackground(java.awt.Color.white);
					spesso.setBackground(java.awt.Color.white);
				}
			if(immagine=="giallo")
				{
					fine.setBackground(java.awt.Color.yellow);
					spesso.setBackground(java.awt.Color.yellow);
				}
			if(immagine=="blu")
				{
					fine.setBackground(java.awt.Color.blue);
					spesso.setBackground(java.awt.Color.blue);
				}
			if(immagine=="verde")
				{
					fine.setBackground(java.awt.Color.green);
					spesso.setBackground(java.awt.Color.green);
				}
			if(immagine=="rosso")
				{
					fine.setBackground(java.awt.Color.red);
					spesso.setBackground(java.awt.Color.red);
				}
                compute = true;
                scale="2.0";
        }
            if((c=='s' || c=='S') && finestra==2)	//spesso
				{
            spesso.setBackground(java.awt.Color.pink);
            if(immagine=="nero")
				{
					fine.setBackground(java.awt.Color.black);
					medio.setBackground(java.awt.Color.black);
				}
			if(immagine=="bianco")
				{
					fine.setBackground(java.awt.Color.white);
					medio.setBackground(java.awt.Color.white);
				}
			if(immagine=="giallo")
				{
					fine.setBackground(java.awt.Color.yellow);
					medio.setBackground(java.awt.Color.yellow);
				}
			if(immagine=="blu")
				{
					fine.setBackground(java.awt.Color.blue);
					medio.setBackground(java.awt.Color.blue);
				}
			if(immagine=="verde")
				{
					fine.setBackground(java.awt.Color.green);
					medio.setBackground(java.awt.Color.green);
				}
			if(immagine=="rosso")
				{
					fine.setBackground(java.awt.Color.red);
					medio.setBackground(java.awt.Color.red);
				}
                compute = true;
                scale="3.0";
        }
            if((c=='b' || c=='B') && finestra==2)	//bassa
				{
			bassa.setBackground(java.awt.Color.pink);
			if(immagine=="nero")
				{
					alta.setBackground(java.awt.Color.black);
					media.setBackground(java.awt.Color.black);
				}
			if(immagine=="bianco")
				{
					alta.setBackground(java.awt.Color.white);
					media.setBackground(java.awt.Color.white);
				}
			if(immagine=="giallo")
				{
					alta.setBackground(java.awt.Color.yellow);
					media.setBackground(java.awt.Color.yellow);
				}
			if(immagine=="blu")
				{
					alta.setBackground(java.awt.Color.blue);
					media.setBackground(java.awt.Color.blue);
				}
			if(immagine=="verde")
				{
					alta.setBackground(java.awt.Color.green);
					media.setBackground(java.awt.Color.green);
				}
			if(immagine=="rosso")
				{
					alta.setBackground(java.awt.Color.red);
					media.setBackground(java.awt.Color.red);
				}
                val=true;
                lower="12.0";
                higher="16.0";
        }
            if((c=='n' || c=='N') && finestra==2)	//media
				{
            media.setBackground(java.awt.Color.pink);
			if(immagine=="nero")
				{
					alta.setBackground(java.awt.Color.black);
					bassa.setBackground(java.awt.Color.black);
				}
			if(immagine=="bianco")
				{
					alta.setBackground(java.awt.Color.white);
					bassa.setBackground(java.awt.Color.white);
				}
			if(immagine=="giallo")
				{
					alta.setBackground(java.awt.Color.yellow);
					bassa.setBackground(java.awt.Color.yellow);
				}
			if(immagine=="blu")
				{
					alta.setBackground(java.awt.Color.blue);
					bassa.setBackground(java.awt.Color.blue);
				}
			if(immagine=="verde")
				{
					alta.setBackground(java.awt.Color.green);
					bassa.setBackground(java.awt.Color.green);
				}
			if(immagine=="rosso")
				{
					alta.setBackground(java.awt.Color.red);
					bassa.setBackground(java.awt.Color.red);
				}
                val=true;
                lower="8.0";
                higher="12.0";
        }
            if((c=='a' || c=='A') && finestra==2)	//alta
				{
					alta.setBackground(java.awt.Color.pink);
				if(immagine=="nero")
					{
						media.setBackground(java.awt.Color.black);
						bassa.setBackground(java.awt.Color.black);
					}
				if(immagine=="bianco")
					{
						media.setBackground(java.awt.Color.white);
						bassa.setBackground(java.awt.Color.white);
					}
				if(immagine=="giallo")
					{
						media.setBackground(java.awt.Color.yellow);
						bassa.setBackground(java.awt.Color.yellow);
					}
				if(immagine=="blu")
					{
						media.setBackground(java.awt.Color.blue);
						bassa.setBackground(java.awt.Color.blue);
					}
				if(immagine=="verde")
					{
						media.setBackground(java.awt.Color.green);
						bassa.setBackground(java.awt.Color.green);
					}
				if(immagine=="rosso")
					{
						media.setBackground(java.awt.Color.red);
						bassa.setBackground(java.awt.Color.red);
					}
					val=true;
					lower="2.0";
					higher="6.0";
				}
			if((c=='r' || c=='R') && finestra==2)	//reimposta
				{
					frame.setVisible(false);
					init1();
					compute=false;
					val=false;
				}
			if((c=='i' || c=='I') && finestra==2)		//inverti
				{
					aux=sfondo;
					sfondo=immagine;
					immagine=aux;

					if(sfondo=="giallo")
					{
						panel.setBackground(java.awt.Color.yellow);
						label1.setBackground(java.awt.Color.yellow);
						label2.setBackground(java.awt.Color.yellow);
						fine.setForeground(java.awt.Color.yellow);
						medio.setForeground(java.awt.Color.yellow);
						spesso.setForeground(java.awt.Color.yellow);
						bassa.setForeground(java.awt.Color.yellow);
						media.setForeground(java.awt.Color.yellow);
						alta.setForeground(java.awt.Color.yellow);
						crea.setForeground(java.awt.Color.yellow);
						reimposta.setForeground(java.awt.Color.yellow);
						inverti.setForeground(java.awt.Color.yellow);
						carica.setForeground(java.awt.Color.yellow);
					}
				if(sfondo=="bianco")
					{
						panel.setBackground(java.awt.Color.white);
						label1.setBackground(java.awt.Color.white);
						label2.setBackground(java.awt.Color.white);
						fine.setForeground(java.awt.Color.white);
						medio.setForeground(java.awt.Color.white);
						spesso.setForeground(java.awt.Color.white);
						bassa.setForeground(java.awt.Color.white);
						media.setForeground(java.awt.Color.white);
						alta.setForeground(java.awt.Color.white);
						crea.setForeground(java.awt.Color.white);
						reimposta.setForeground(java.awt.Color.white);
						inverti.setForeground(java.awt.Color.white);
						carica.setForeground(java.awt.Color.white);
					}
				if(sfondo=="nero")
					{
						panel.setBackground(java.awt.Color.black);
						label1.setBackground(java.awt.Color.black);
						label2.setBackground(java.awt.Color.black);
						fine.setForeground(java.awt.Color.black);
						medio.setForeground(java.awt.Color.black);
						spesso.setForeground(java.awt.Color.black);
						bassa.setForeground(java.awt.Color.black);
						media.setForeground(java.awt.Color.black);
						alta.setForeground(java.awt.Color.black);
						crea.setForeground(java.awt.Color.black);
						reimposta.setForeground(java.awt.Color.black);
						inverti.setForeground(java.awt.Color.black);
						carica.setForeground(java.awt.Color.black);
					}
				if(sfondo=="blu")
					{
						panel.setBackground(java.awt.Color.blue);
						label1.setBackground(java.awt.Color.blue);
						label2.setBackground(java.awt.Color.blue);
						fine.setForeground(java.awt.Color.blue);
						medio.setForeground(java.awt.Color.blue);
						spesso.setForeground(java.awt.Color.blue);
						bassa.setForeground(java.awt.Color.blue);
						media.setForeground(java.awt.Color.blue);
						alta.setForeground(java.awt.Color.blue);
						crea.setForeground(java.awt.Color.blue);
						reimposta.setForeground(java.awt.Color.blue);
						inverti.setForeground(java.awt.Color.blue);
						carica.setForeground(java.awt.Color.blue);
					}
				if(sfondo=="verde")
					{
						panel.setBackground(java.awt.Color.green);
						label1.setBackground(java.awt.Color.green);
						label2.setBackground(java.awt.Color.green);
						fine.setForeground(java.awt.Color.green);
						medio.setForeground(java.awt.Color.green);
						spesso.setForeground(java.awt.Color.green);
						bassa.setForeground(java.awt.Color.green);
						media.setForeground(java.awt.Color.green);
						alta.setForeground(java.awt.Color.green);
						crea.setForeground(java.awt.Color.green);
						reimposta.setForeground(java.awt.Color.green);
						inverti.setForeground(java.awt.Color.green);
						carica.setForeground(java.awt.Color.green);
					}
				if(sfondo=="rosso")
					{
						panel.setBackground(java.awt.Color.red);
						label1.setBackground(java.awt.Color.red);
						label2.setBackground(java.awt.Color.red);
						fine.setForeground(java.awt.Color.red);
						medio.setForeground(java.awt.Color.red);
						spesso.setForeground(java.awt.Color.red);
						bassa.setForeground(java.awt.Color.red);
						media.setForeground(java.awt.Color.red);
						alta.setForeground(java.awt.Color.red);
						crea.setForeground(java.awt.Color.red);
						reimposta.setForeground(java.awt.Color.red);
						inverti.setForeground(java.awt.Color.red);
						carica.setForeground(java.awt.Color.red);
					}
				if(immagine=="blu")
					{
						panel.setForeground(java.awt.Color.blue);
						label1.setForeground(java.awt.Color.blue);
						label2.setForeground(java.awt.Color.blue);
						fine.setBackground(java.awt.Color.blue);
						medio.setBackground(java.awt.Color.blue);
						spesso.setBackground(java.awt.Color.blue);
						bassa.setBackground(java.awt.Color.blue);
						media.setBackground(java.awt.Color.blue);
						alta.setBackground(java.awt.Color.blue);
						crea.setBackground(java.awt.Color.blue);
						reimposta.setBackground(java.awt.Color.blue);
						inverti.setBackground(java.awt.Color.blue);
						carica.setBackground(java.awt.Color.blue);
					}
				if(immagine=="nero")
					{
						panel.setForeground(java.awt.Color.black);
						label1.setForeground(java.awt.Color.black);
						label2.setForeground(java.awt.Color.black);
						fine.setBackground(java.awt.Color.black);
						medio.setBackground(java.awt.Color.black);
						spesso.setBackground(java.awt.Color.black);
						bassa.setBackground(java.awt.Color.black);
						media.setBackground(java.awt.Color.black);
						alta.setBackground(java.awt.Color.black);
						crea.setBackground(java.awt.Color.black);
						reimposta.setBackground(java.awt.Color.black);
						inverti.setBackground(java.awt.Color.black);
						carica.setBackground(java.awt.Color.black);
					}
				if(immagine=="bianco")
					{
						panel.setForeground(java.awt.Color.white);
						label1.setForeground(java.awt.Color.white);
						label2.setForeground(java.awt.Color.white);
						fine.setBackground(java.awt.Color.white);
						medio.setBackground(java.awt.Color.white);
						spesso.setBackground(java.awt.Color.white);
						bassa.setBackground(java.awt.Color.white);
						media.setBackground(java.awt.Color.white);
						alta.setBackground(java.awt.Color.white);
						crea.setBackground(java.awt.Color.white);
						reimposta.setBackground(java.awt.Color.white);
						inverti.setBackground(java.awt.Color.white);
						carica.setBackground(java.awt.Color.white);
					}
				if(immagine=="giallo")
					{
						panel.setForeground(java.awt.Color.yellow);
						label1.setForeground(java.awt.Color.yellow);
						label2.setForeground(java.awt.Color.yellow);
						fine.setBackground(java.awt.Color.yellow);
						medio.setBackground(java.awt.Color.yellow);
						spesso.setBackground(java.awt.Color.yellow);
						bassa.setBackground(java.awt.Color.yellow);
						media.setBackground(java.awt.Color.yellow);
						alta.setBackground(java.awt.Color.yellow);
						crea.setBackground(java.awt.Color.yellow);
						reimposta.setBackground(java.awt.Color.yellow);
						inverti.setBackground(java.awt.Color.yellow);
						carica.setBackground(java.awt.Color.yellow);
					}
				if(immagine=="verde")
					{
						panel.setForeground(java.awt.Color.green);
						label1.setForeground(java.awt.Color.green);
						label2.setForeground(java.awt.Color.green);
						fine.setBackground(java.awt.Color.green);
						medio.setBackground(java.awt.Color.green);
						spesso.setBackground(java.awt.Color.green);
						bassa.setBackground(java.awt.Color.green);
						media.setBackground(java.awt.Color.green);
						alta.setBackground(java.awt.Color.green);
						crea.setBackground(java.awt.Color.green);
						reimposta.setBackground(java.awt.Color.green);
						inverti.setBackground(java.awt.Color.green);
						carica.setBackground(java.awt.Color.green);
					}
				if(immagine=="rosso")
					{
						panel.setForeground(java.awt.Color.red);
						label1.setForeground(java.awt.Color.red);
						label2.setForeground(java.awt.Color.red);
						fine.setBackground(java.awt.Color.red);
						medio.setBackground(java.awt.Color.red);
						spesso.setBackground(java.awt.Color.red);
						bassa.setBackground(java.awt.Color.red);
						media.setBackground(java.awt.Color.red);
						alta.setBackground(java.awt.Color.red);
						crea.setBackground(java.awt.Color.red);
						reimposta.setBackground(java.awt.Color.red);
						inverti.setBackground(java.awt.Color.red);
						carica.setBackground(java.awt.Color.red);
					}
					compute=false;
					val=false;
				}
        }

    private void error(final String message) { msg.error("IPO_Edges: Errore", message+"."); }

    private final Messenger msg = new Messenger();

    public void keyPressed(KeyEvent ev) {}
    public void keyReleased(KeyEvent ev) {}

}


